Index: /trunk/SophyaLib/Mgr/Makefile
===================================================================
--- /trunk/SophyaLib/Mgr/Makefile	(revision 1454)
+++ /trunk/SophyaLib/Mgr/Makefile	(revision 1455)
@@ -17,5 +17,5 @@
 cxxlibs:  SysTools TArray NTools HiStats SkyMap Samba SkyT
 
-cxxextlibs:  FitsIOServer IFFTW LinAlg
+cxxextlibs:  FitsIOServer IFFTW LinAlg XAstroPack
 
 #--- Create directory and copy includes for install
@@ -79,4 +79,8 @@
 	if [ -d LinAlg ] ; then cd  LinAlg ; $(MAKE) ; fi
  
+.PHONY:  XAstroPack
+XAstroPack:
+	if [ -d XAstroPack ] ; then cd  XAstroPack ; $(MAKE) ; fi
+ 
 .PHONY: PI
 PI:
@@ -87,10 +91,10 @@
 #  List of libraries (.a)
 PSLB =  $(LIB)libSysTools.a $(LIB)libTArray.a $(LIB)libNTools.a $(LIB)libHiStats.a $(LIB)libSkyMap.a $(LIB)libSamba.a $(LIB)libSkyT.a
-EXTPSLB =  $(LIB)libFitsIOServer.a $(LIB)libIFFTW.a $(LIB)libLinAlg.a
+EXTPSLB =  $(LIB)libFitsIOServer.a $(LIB)libIFFTW.a $(LIB)libLinAlg.a $(LIB)libXAstroPack.a
 PIPSLB =  $(LIB)libPI.a  $(LIB)libPIext.a
 
 #  List of external library references
-EXTLIBL  = -L$(EXTLIBPATH) -lcfitsio -lfftw -lrfftw 
-EXTSLBL  = -L$(EXTSLBPATH) -lcfitsio -lfftw 
+EXTLIBL  = -L$(EXTLIBPATH) -lcfitsio -lfftw -lrfftw -lxastro
+EXTSLBL  = -L$(EXTSLBPATH) -lcfitsio -lfftw -lrfftw -lxastro
 
 # defining the other external libraries needed on different systems
@@ -138,6 +142,7 @@
 OBJIFFTW = $(shell echo `cat ./IFFTW/objlist.list `)
 OBJLinAlg = $(shell echo `cat ./LinAlg/objlist.list `)
-ALLEXTOBJS = $(OBJFitsIOServer) $(OBJIFFTW) $(OBJLinAlg)
- 
+OBJXAstroPack = $(shell echo `cat ./XAstroPack/objlist.list `)
+ALLEXTOBJS = $(OBJFitsIOServer) $(OBJIFFTW) $(OBJLinAlg) $(OBJXAstroPack)
+
 # List of .o files for PI modules 
 OBJPI = $(shell echo `cat ./PI/objlist.list `)
Index: /trunk/SophyaLib/Mgr/README
===================================================================
--- /trunk/SophyaLib/Mgr/README	(revision 1454)
+++ /trunk/SophyaLib/Mgr/README	(revision 1455)
@@ -19,4 +19,6 @@
 * LinAlg/        Interface with Lapack linear algebra package
 * IFFTW/         Interface with FFTW package
+* XAstroPack/    Interface with astronomy library (XEphem)
+                 Code is into the SOPHYA module XephemAstroLib
 
 
Index: /trunk/SophyaLib/Mgr/extlibdirs
===================================================================
--- /trunk/SophyaLib/Mgr/extlibdirs	(revision 1454)
+++ /trunk/SophyaLib/Mgr/extlibdirs	(revision 1455)
@@ -2,2 +2,3 @@
 IFFTW
 LinAlg
+XAstroPack
Index: /trunk/SophyaLib/Mgr/makefileuser.inc
===================================================================
--- /trunk/SophyaLib/Mgr/makefileuser.inc	(revision 1454)
+++ /trunk/SophyaLib/Mgr/makefileuser.inc	(revision 1455)
@@ -35,6 +35,6 @@
 #--------- lib sophya interface externes ---------
 ifndef NOEXTLIB
-LIBF := $(LIBF) $(LIB)libFitsIOServer.a $(LIB)libIFFTW.a $(LIB)libLinAlg.a
-LIBS := $(LIBS) -lFitsIOServer -lIFFTW -lLinAlg
+LIBF := $(LIBF) $(LIB)libFitsIOServer.a $(LIB)libIFFTW.a $(LIB)libLinAlg.a $(LIB)libXAstroPack.a
+LIBS := $(LIBS) -lFitsIOServer -lIFFTW -lLinAlg -lXAstroPack
 #LIBF := $(LIBF)libBlitz.a
 #LIBS := $(LIBS) -lBlitz
@@ -49,6 +49,6 @@
 #--------- Other Extern Libraries ---------
 ifndef NOEXTLIB
-ELIBF := $(ELIBF) $(EXTLIBPATH)libcfitsio.a $(EXTLIBPATH)libfftw.a $(EXTLIBPATH)librfftw.a
-ELIBS := $(ELIBS) -L$(EXTLIBPATH) -lcfitsio -lfftw -lrfftw
+ELIBF := $(ELIBF) $(EXTLIBPATH)libcfitsio.a $(EXTLIBPATH)libfftw.a $(EXTLIBPATH)librfftw.a $(EXTLIBPATH)libxastro.a
+ELIBS := $(ELIBS) -L$(EXTLIBPATH) -lcfitsio -lfftw -lrfftw -lxastro
 ifeq ($(MACHEROS),OSF1)
 ELIBS := $(ELIBS) -ldxml
@@ -104,6 +104,6 @@
 # on pourrait appeller les blabla.so (EXTSLBPATH) si on les avait crees
 ifndef NOEXTLIB
-ELIBF := $(ELIBF) $(EXTLIBPATH)libcfitsio.a $(EXTLIBPATH)libfftw.a $(EXTLIBPATH)librfftw.a
-ELIBS := $(ELIBS) -L$(EXTLIBPATH) -lcfitsio -lfftw -lrfftw
+ELIBF := $(ELIBF) $(EXTLIBPATH)libcfitsio.a $(EXTLIBPATH)libfftw.a $(EXTLIBPATH)librfftw.a $(EXTLIBPATH)libxastro.a
+ELIBS := $(ELIBS) -L$(EXTLIBPATH) -lcfitsio -lfftw -lrfftw  -lxastro
 ifeq ($(MACHEROS),OSF1)
 ELIBS := $(ELIBS) -ldxml
Index: /trunk/SophyaLib/Mgr/mkslbsgi.csh
===================================================================
--- /trunk/SophyaLib/Mgr/mkslbsgi.csh	(revision 1454)
+++ /trunk/SophyaLib/Mgr/mkslbsgi.csh	(revision 1455)
@@ -25,6 +25,6 @@
 set EXTSLBPL = -L${EXTLIBDIR}/IRIX64-CC/ShLibs/
 
-set EXTLIBL  = "${EXTLIBPL} -lcfitsio -lfftw -lrfftw "
-set EXTSLBL  = "${EXTSLBPL} -lcfitsio -lfftw "
+set EXTLIBL  = "${EXTLIBPL} -lcfitsio -lfftw -lrfftw -lxastro"
+set EXTSLBL  = "${EXTSLBPL} -lcfitsio -lfftw -lrfftw -lxastro"
 
 
@@ -41,5 +41,6 @@
 set OBJIFFTW = `cat ./IFFTW/objlist.list `
 set OBJLinAlg = `cat ./LinAlg/objlist.list `
-set ALLEXTOBJS = ( $OBJFitsIOServer $OBJIFFTW $OBJLinAlg )
+set OBJXAstroPack = `cat ./XAstroPack/objlist.list `
+set ALLEXTOBJS = ( $OBJFitsIOServer $OBJIFFTW $OBJLinAlg $OBJXAstroPack )
 
 set OBJPI = `cat ./PI/objlist.list `